﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

namespace WpfSumBoundUnbound
{
    public class InvoiceCollection : List<Invoice>
    {
    }

    public class Invoice : DependencyObject
    {
        //Descr
        public static readonly DependencyProperty DescrProperty = DependencyProperty.Register("Descr", typeof(string), typeof(Invoice), new FrameworkPropertyMetadata(null, FrameworkPropertyMetadataOptions.BindsTwoWayByDefault, new PropertyChangedCallback(DescrChanged), null));
        public string Descr
        {
            //Do not change anything here! WPF won't call the wrapper but set the DependencyProperty directly... :(
            get { return (string)GetValue(DescrProperty); }
            set { SetValue(DescrProperty, value); }
        }
        static void DescrChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
        {
            Invoice invoice = (Invoice)obj;
        }

        //TotalAmount
        public static readonly DependencyProperty TotalAmountProperty = DependencyProperty.Register("TotalAmount", typeof(decimal?), typeof(Invoice), new FrameworkPropertyMetadata(null, FrameworkPropertyMetadataOptions.BindsTwoWayByDefault, new PropertyChangedCallback(TotalAmountChanged), null));
        public decimal? TotalAmount
        {
            //Do not change anything here! WPF won't call the wrapper but set the DependencyProperty directly... :(
            get { return (decimal?)GetValue(TotalAmountProperty); }
            set { SetValue(TotalAmountProperty, value); }
        }
        static void TotalAmountChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
        {
            Invoice invoice = (Invoice)obj;
        }
    }
}
